//
//  RootViewController.m
//  Table_Navi
//
//  Created by kunii on 10/03/22.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "RootViewController.h"
#import "AnotherViewController.h"
#import "MyClass.h"

@implementation RootViewController

-(void)setInstanceArray:(NSMutableArray*)inArray {
	if (instanceArray != inArray) {
		[instanceArray release];
		instanceArray = [inArray retain];
	}
}

- (void)viewDidLoad {
    [super viewDidLoad];
	self.title = @"トップテーブル";
	self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release anything that can be recreated in viewDidLoad or on demand.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

/*
	項目数はここで返す。
*/
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [instanceArray count];
}

/*
	項目内容はここで決定する。
*/
- (UITableViewCell *)tableView:(UITableView *)tableView 
	cellForRowAtIndexPath:(NSIndexPath *)indexPath {

	static NSString *CellIdentifier = @"Cell";

	UITableViewCell *cell = [tableView 
		dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] 
			initWithStyle:UITableViewCellStyleDefault 
			reuseIdentifier:CellIdentifier] autorelease];
	}

	MyClass*  m = [instanceArray objectAtIndex:indexPath.row];
	cell.textLabel.text = [m name];
	return cell;
}

/*
	項目がタップされたので次のビューにドリルダウンする。
*/
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherViewController" bundle:nil];
	MyClass*  m = [instanceArray objectAtIndex:indexPath.row];
	anotherViewController.title = [m name];
	[self.navigationController pushViewController:anotherViewController animated:YES];
	[anotherViewController release];
}

/*
	最上位項目だけ編集不可とする。
*/
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
	if (indexPath.row == 0)
		return NO;
    return YES;
}

/*
	削除、挿入処理に対応する。
*/
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
		[instanceArray removeObjectAtIndex:indexPath.row];
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
		//	新しいMyClassインスタンスの作成
		MyClass* m = [[MyClass alloc] init];
		static int addIndex = 100;	//	新規挿入項目だとわかるように100番台にした。
		[m set:addIndex++];
#if 1	//	後ろに追加する
		[instanceArray insertObject:m atIndex:indexPath.row + 1];
		[tableView insertRowsAtIndexPaths:[NSArray arrayWithObject:[NSIndexPath indexPathForRow:indexPath.row + 1 inSection:indexPath.section]] withRowAnimation:UITableViewRowAnimationFade];
#else	//	手前に挿入する
		[instanceArray insertObject:m atIndex:indexPath.row];
		[tableView insertRowsAtIndexPaths:
			[NSArray arrayWithObject:indexPath] 
			withRowAnimation:UITableViewRowAnimationFade];
		[tableView reloadRowsAtIndexPaths:
			[NSArray arrayWithObject:
				[NSIndexPath indexPathForRow:indexPath.row + 1 
				inSection:indexPath.section]] 
			withRowAnimation:UITableViewRowAnimationNone];
#endif
		[m release];
   }   
}

/*
	第1項目にだけ挿入ボタンを表示させ、それ以外は削除ボタンとする。
*/
- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath {
	if (indexPath.row == 1) {
		return UITableViewCellEditingStyleInsert;
	}
	return UITableViewCellEditingStyleDelete;
}

// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
	int toIndex = toIndexPath.row;
	int fromIndex = fromIndexPath.row;
	id obj = [instanceArray objectAtIndex:fromIndex];
	[obj retain];	//	removeObjectAtIndex時にreleaseが
					//	呼ばれるから解放されないように一時的にretainする
	[instanceArray removeObjectAtIndex:fromIndex];
	[instanceArray insertObject:obj atIndex:toIndex];
	[obj release];	//	instanceArrayにretainされたので、こちらは解放する
}


// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
	if (indexPath.row == 1) {
		return NO;
	}
	return YES;
}

- (NSIndexPath *)tableView:(UITableView *)tableView 
	targetIndexPathForMoveFromRowAtIndexPath:(NSIndexPath *)sourceIndexPath 
	   toProposedIndexPath:(NSIndexPath *)proposedDestinationIndexPath {
	if (proposedDestinationIndexPath.row < 2) {
		return [NSIndexPath indexPathForRow:2 inSection:proposedDestinationIndexPath.section];
	}
	return proposedDestinationIndexPath;
}


- (void)dealloc {
	[instanceArray release];
    [super dealloc];
}


@end
